> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/ios/layers-ocgs/extract-layer.md).

# Extract layers from PDF on iOS

Learn how to extract PDF layers or OCG (optional content group) from a document with full sample code. Create, extract, and render PDF layers effortlessly. The Apryse iOS SDK streamlines secure docume

To extract PDF layers or OCG (optional content group) from a document.

{% tabs %}
{% tab title="Obj-C" %}
{% code lineNumbers="true" %}

```objc
PTPDFDoc *doc = [[PTPDFDoc alloc] initWithFilepath: filename];
PTPage *page = [doc GetPage: 1];

PTConfig *init_cfg = [doc GetOCGConfig];
PTContext *ctx = [[PTContext alloc] initWithConfig: init_cfg];

PTPDFDraw *pdfdraw = [[PTPDFDraw alloc] initWithDpi: 92];
[pdfdraw SetImageSize: 1000 height: 1000 preserve_aspect_ratio: YES];
[pdfdraw SetOCGContext: ctx]; // Render the page using the given OCG context.

// Disable drawing of content that is not optional (i.e. is not part of any layer).
[ctx SetNonOCDrawing: NO];

// Now render each layer in the input document to a separate image.
PTObj * ocgs = [doc GetOCGs]; // Get the array of all OCGs in the document.
unsigned long i, sz = [ocgs Size];
for (i=0; i<sz; ++i) {
    PTGroup *ocg = [[PTGroup alloc] initWithOcg: [ocgs GetAt: i]];
    [ctx ResetStates: NO];
    [ctx SetState: ocg state: YES];
    NSString* fname = [output_path stringByAppendingFormat: @"pdf_layers_%@.png", [ocg GetName]];
    [pdfdraw  page filename: fname format: @"PNG"];
}

// Now draw content that is not part of any layer...
[ctx SetNonOCDrawing: YES];
[ctx SetOCDrawMode: e_ptNoOC];
[pdfdraw  page filename: [output_path stringByAppendingString: @"pdf_layers_non_oc.png"] format: @"PNG" ];
```

{% endcode %}
{% endtab %}

{% tab title="Swift" %}
{% code lineNumbers="true" %}

```swift
let doc: PTPDFDoc = PTPDFDoc(filepath: filename)
let page: PTPage = doc.getPage(1)

let init_cfg: PTConfig = doc.getOCGConfig()
let ctx: PTContext = PTContext(config: init_cfg)

let pdfdraw: PTPDFDraw = PTPDFDraw(dpi: 92)
pdfdraw.setImageSize(1000, height: 1000, preserve_aspect_ratio: true)
pdfdraw.setOCGContext(ctx)    // Render the page using the given OCG context.

// Disable drawing of content that is not optional (i.e. is not part of any layer).
ctx.setNonOCDrawing(false)

// Now render each layer in the input document to a separate image.
let ocgs: PTObj = doc.getOCGs() {    // Get the array of all OCGs in the document.
var _: UInt = 0
let sz: UInt = ocgs.size()
for i in 0..<sz {
    let ocg: PTGroup = PTGroup(ocg: ocgs.getAt(i))
    ctx.resetStates(false)
    ctx.setState(ocg, state: true)
    let fname: String = output_path + "pdf_layers_\(ocg.getName()).png")
    pdfdraw.export(page, filename: fname, format: "PNG")
}

// Now draw content that is not part of any layer...
ctx.setNonOCDrawing(true)
ctx.setOCDrawMode(e_ptNoOC)
pdfdraw.export(page, filename: output_path + "pdf_layers_non_oc.png", format: "PNG")
```

{% endcode %}
{% endtab %}
{% endtabs %}

[PDF layers (OCG)](/ios/get-started/samples.md#pdflayers) Full sample code which demonstrates how to create, extract, render PDF layers.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.apryse.com/ios/layers-ocgs/extract-layer.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
